﻿using System;
using System.Threading.Tasks;
using TourDataManager;
using TourDataManager.Entities;

namespace TourDataManagerConsoleApplication {
    internal class Program {
        
        const string PersistentPath = "C:\\Users\\Bigantounity\\AppData\\LocalLow\\Biganto\\StandalonePlayer";
        
        const string defaultLogin = "demo@biganto.ru";
        const string defaultPassword = "demo";
        
        public static void Main(string[] args){
            
            var tourDataManager = new TourDataManager.TourDataManager(PersistentPath);
            //tourDataManager.Login(defaultLogin, defaultPassword);
            AsyncMethod(tourDataManager);
            
            Console.Read();
        }

        public static async void AsyncMethod(TourDataManager.TourDataManager plugin){
            try{

                var estates = await plugin.DownloadEstates();
                foreach (var estate in estates){
                    Debug.Log(estate);
                    var tours = await plugin.DownloadTourPreviews(estate.Id);
                    foreach (var tour in tours){
                        Debug.Log(tour);
                    }
                }
            } catch (Exception e){
                Debug.Log(e);
            }
            
            
        }

    }
}